package jcg.zheng.demo.customannotation;

import java.lang.annotation.Annotation;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class ConsumeEmployeeAnnotation {
	public static void main(String[] args) {
		MarkEmployeeAnnotation ex = new MarkEmployeeAnnotation();
		System.out.println("Checking class methods for annotation...\n");

		// get all the methods of this class
		for (Method method : ex.getClass().getMethods()) {

			// Check if a method has the @Employee annotation
			if (method.isAnnotationPresent(EmployeeAnnotation.class)) {

				if (method.getAnnotation(EmployeeAnnotation.class) != null) {
					System.out.println(method.getName() + " has the @Employee annotation.");
					for (Annotation an : method.getAnnotations()) {
						System.out.println("\t" + an.toString());
						processAnnotation((EmployeeAnnotation) an);
					}

					try {
						method.invoke(ex);
					} catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
						e.printStackTrace();
					}

				}
			} else {
				System.out.println(method.getName() + " does not have specific annotation.");
			}
		}
	}

	private static void processAnnotation(EmployeeAnnotation emp) {
		System.out.println("Can do cross-cutting for all the @Employee here");
		System.out.println(emp.job());
		System.out.println(emp.age());
		System.out.println(emp.name());
	}

}
