package jcg.zheng.demo.web.data;

import javax.validation.constraints.Max;
import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.springframework.beans.BeanUtils;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonInclude(JsonInclude.Include.NON_EMPTY)
public class User {

	@NotNull
	@Size(max = 20, min = 3)
	private String firstName;

	private int id;

	@NotNull
	@Size(max = 50, min = 3)
	private String lastName;

	@Min(value = 0)
	@Max(value = 10)
	private int role;

	public User() {
		super();
	}

	public User(Person person) {
		BeanUtils.copyProperties(person, this);
	}

	public String getFirstName() {
		return firstName;
	}

	public Integer getId() {
		return id;
	}

	public String getLastName() {
		return lastName;
	}

	public int getRole() {
		return role;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	public void setRole(int role) {
		this.role = role;
	}
}
