package jcg.zheng.demo.web.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import jcg.zheng.demo.customannotation.RequiresPermissions;
import jcg.zheng.demo.web.api.UserResource;
import jcg.zheng.demo.web.data.User;

@Component
public class UserResourceImpl implements UserResource {

	@Autowired
	private UserService userSrv;

	@Override
	@RequiresPermissions(type = "role", value = "10")
	public User createUser(User user) {
		return userSrv.saveUser(user);
	}

	@Override
	@RequiresPermissions(type = "role", value = "1")
	public List<User> getUsers() {
		return userSrv.getUsers();
	}
}
